## ros-ros-comm 1.13.5+ds1

=== ros_comm/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(ros_comm)
find_package(catkin REQUIRED)
catkin_metapackage()

=== clients/roscpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(roscpp)

if(NOT WIN32)
  set_directory_properties(PROPERTIES COMPILE_OPTIONS "-std=c++11;-Wall;-Wextra")
endif()

find_package(catkin REQUIRED COMPONENTS
  cpp_common message_generation rosconsole roscpp_serialization roscpp_traits rosgraph_msgs rostime std_msgs xmlrpcpp
)

catkin_package_xml()
# split version in parts and pass to extra file
string(REPLACE "." ";" roscpp_VERSION_LIST "${roscpp_VERSION}")
list(LENGTH roscpp_VERSION_LIST _count)
if(NOT _count EQUAL 3)
  message(FATAL_ERROR "roscpp version '${roscpp_VERSION}' does not match 'MAJOR.MINOR.PATCH' pattern")
endif()
list(GET roscpp_VERSION_LIST 0 roscpp_VERSION_MAJOR)
list(GET roscpp_VERSION_LIST 1 roscpp_VERSION_MINOR)
list(GET roscpp_VERSION_LIST 2 roscpp_VERSION_PATCH)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/include/ros/common.h.in ${CATKIN_DEVEL_PREFIX}/${CATKIN_GLOBAL_INCLUDE_DESTINATION}/ros/common.h)

find_package(Boost REQUIRED COMPONENTS chrono filesystem signals system)

include_directories(include ${CATKIN_DEVEL_PREFIX}/${CATKIN_GLOBAL_INCLUDE_DESTINATION}/ros ${catkin_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})

add_message_files(
  DIRECTORY msg
  FILES Logger.msg
)

add_service_files(
  DIRECTORY srv
  FILES Empty.srv GetLoggers.srv SetLoggerLevel.srv
)

generate_messages()

set(PTHREAD_LIB "")
find_package(Threads)
if(CMAKE_THREAD_LIBS_INIT)
  string(LENGTH ${CMAKE_THREAD_LIBS_INIT} _length)
  if(_length GREATER 2)
    string(SUBSTRING ${CMAKE_THREAD_LIBS_INIT} 0 2 _prefix)
    if(${_prefix} STREQUAL "-l")
      math(EXPR _rest_len "${_length} - 2")
      string(SUBSTRING ${CMAKE_THREAD_LIBS_INIT} 2 ${_rest_len} PTHREAD_LIB)
    endif()
  endif()
endif()

catkin_package(
  INCLUDE_DIRS include ${CATKIN_DEVEL_PREFIX}/${CATKIN_GLOBAL_INCLUDE_DESTINATION}/ros
  LIBRARIES roscpp ${PTHREAD_LIB}
  CATKIN_DEPENDS cpp_common message_runtime rosconsole roscpp_serialization roscpp_traits rosgraph_msgs rostime std_msgs xmlrpcpp
  DEPENDS Boost
)

include(CheckIncludeFiles)
include(CheckFunctionExists)

# Not everybody has <ifaddrs.h> (e.g., embedded arm-linux)
CHECK_INCLUDE_FILES(ifaddrs.h HAVE_IFADDRS_H)
# Not everybody has trunc (e.g., Windows, embedded arm-linux)
CHECK_FUNCTION_EXISTS(trunc HAVE_TRUNC)

# Output test results to config.h
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/libros/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(roscpp 
  src/libros/master.cpp
  src/libros/network.cpp
  src/libros/subscriber.cpp
  src/libros/common.cpp
  src/libros/publisher_link.cpp
  src/libros/service_publication.cpp
  src/libros/connection.cpp
  src/libros/single_subscriber_publisher.cpp
  src/libros/param.cpp
  src/libros/service_server.cpp
  src/libros/wall_timer.cpp
  src/libros/xmlrpc_manager.cpp
  src/libros/publisher.cpp
  src/libros/timer.cpp
  src/libros/io.cpp
  src/libros/names.cpp
  src/libros/topic.cpp
  src/libros/topic_manager.cpp
  src/libros/poll_manager.cpp
  src/libros/publication.cpp
  src/libros/statistics.cpp
  src/libros/intraprocess_subscriber_link.cpp
  src/libros/intraprocess_publisher_link.cpp
  src/libros/callback_queue.cpp
  src/libros/service_server_link.cpp
  src/libros/service_client.cpp
  src/libros/node_handle.cpp
  src/libros/connection_manager.cpp
  src/libros/file_log.cpp
  src/libros/transport/transport.cpp
  src/libros/transport/transport_udp.cpp
  src/libros/transport/transport_tcp.cpp
  src/libros/subscriber_link.cpp
  src/libros/service_client_link.cpp
  src/libros/transport_publisher_link.cpp
  src/libros/transport_subscriber_link.cpp
  src/libros/service_manager.cpp
  src/libros/rosout_appender.cpp
  src/libros/init.cpp
  src/libros/subscription.cpp
  src/libros/subscription_queue.cpp
  src/libros/spinner.cpp
  src/libros/internal_timer_manager.cpp
  src/libros/message_deserializer.cpp
  src/libros/poll_set.cpp
  src/libros/service.cpp
  src/libros/this_node.cpp
  src/libros/steady_timer.cpp
  )

add_dependencies(roscpp ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

target_link_libraries(roscpp
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
  )

#explicitly install library and includes
install(TARGETS roscpp
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})
install(DIRECTORY include/
  DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h")
install(FILES ${CATKIN_DEVEL_PREFIX}/${CATKIN_GLOBAL_INCLUDE_DESTINATION}/ros/common.h
  DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/ros)
# install legacy infrastructure needed by rosbuild
install(FILES rosbuild/roscpp.cmake
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/rosbuild)
catkin_install_python(PROGRAMS
  rosbuild/scripts/genmsg_cpp.py
  rosbuild/scripts/gensrv_cpp.py
  rosbuild/scripts/msg_gen.py
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/rosbuild/scripts)

=== test/test_rosbag_storage/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project(test_rosbag_storage)

find_package(catkin REQUIRED COMPONENTS rosbag_storage std_msgs)

find_package(Boost REQUIRED)

catkin_package()

if(CATKIN_ENABLE_TESTING)
  include_directories(include ${catkin_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})

  catkin_add_gtest(create_and_iterate_bag src/create_and_iterate_bag.cpp)
  if(TARGET create_and_iterate_bag)
    target_link_libraries(create_and_iterate_bag ${catkin_LIBRARIES})
  endif()
  catkin_add_gtest(swap_bags src/swap_bags.cpp)
  if(TARGET swap_bags)
    target_link_libraries(swap_bags ${catkin_LIBRARIES})
  endif()
endif()

=== test/test_roscpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project(test_roscpp)

if(NOT WIN32)
  set_directory_properties(PROPERTIES COMPILE_OPTIONS "-Wall;-Wextra")
endif()

find_package(catkin REQUIRED COMPONENTS
  message_generation roscpp rostest rosunit std_srvs
)

if(CATKIN_ENABLE_TESTING)
  find_package(Boost REQUIRED COMPONENTS signals filesystem system)

  include_directories(include ${catkin_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})

  # Testing message and service files.  See comment below about subdirectory support.
  add_message_files(
    NOINSTALL
    DIRECTORY test/msg
    FILES
    TestArray.msg
    TestEmpty.msg
    TestStringInt.msg
    TestWithHeader.msg
  )
  add_service_files(
    NOINSTALL
    DIRECTORY test/srv
    FILES
    BadTestStringString.srv
    TestStringString.srv
  )

  # Serialization testing message files.
  add_message_files(
    NOINSTALL
    DIRECTORY test_serialization/msg
    FILES
    ArrayOfFixedLength.msg
    ArrayOfVariableLength.msg
    Constants.msg
    CustomHeader.msg
    EmbeddedExternal.msg
    EmbeddedFixedLength.msg
    EmbeddedVariableLength.msg
    FixedLengthArrayOfExternal.msg
    FixedLength.msg
    FixedLengthStringArray.msg
    HeaderNotFirstMember.msg
    VariableLengthArrayOfExternal.msg
    VariableLength.msg
    VariableLengthStringArray.msg
    WithDuration.msg
    WithHeader.msg
    WithMemberNamedHeaderThatIsNotAHeader.msg
    WithTime.msg
  )

  # Performance testing message files.  add_message_files() does not
  # currently support being called from a subdirectory, so this is here
  # for now.
  add_message_files(
    NOINSTALL
    DIRECTORY perf/msg
    FILES
    LatencyMessage.msg
    ThroughputMessage.msg
  )

  # Message files for testing the performance of serialization.
  add_message_files(
    NOINSTALL
    DIRECTORY perf_serialization/msg
    FILES
    ChannelFloat32.msg
    Point32.msg
    PointCloud.msg
  )

  # dependencies std_msgs and rosgraph_msgs are needed by tests, but not by roscpp otherwise.
  generate_messages(DEPENDENCIES rosgraph_msgs std_msgs)
endif()

catkin_package(
  CATKIN_DEPENDS message_runtime rosconsole rosgraph_msgs std_msgs xmlrpcpp
)

if(CATKIN_ENABLE_TESTING)
  add_subdirectory(test)
  add_subdirectory(perf)
  add_subdirectory(test_serialization)
  add_subdirectory(perf_serialization)
endif()

=== test/test_roslib_comm/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project(test_roslib_comm)
find_package(catkin REQUIRED COMPONENTS genmsg rosgraph_msgs std_msgs)

if(CATKIN_ENABLE_TESTING)
  add_message_files(DIRECTORY msg
    FILES
    ArrayOfMsgs.msg
    FieldNameChange1.msg
    FieldNameChange2.msg
    FillEmbedTime.msg
    FillSimple.msg
    HeaderTest.msg
    SameSubMsg1.msg
    SameSubMsg2.msg
    SameSubMsg3.msg
    TypeNameChange1.msg
    TypeNameChange2.msg
    TypeNameChangeArray1.msg
    TypeNameChangeArray2.msg
    TypeNameChangeComplex1.msg
    TypeNameChangeComplex2.msg
    NOINSTALL
    )
  generate_messages(DEPENDENCIES rosgraph_msgs std_msgs)
endif()

catkin_package()

if(CATKIN_ENABLE_TESTING)
  catkin_add_nosetests(test)
endif()

=== test/test_rosparam/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project(test_rosparam)
find_package(catkin REQUIRED COMPONENTS rostest)
catkin_package()

if(CATKIN_ENABLE_TESTING)
  add_rostest(test/rosparam.test)

  catkin_add_nosetests(test)
endif()

=== test/test_rostopic/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project(test_rostopic)

find_package(catkin REQUIRED COMPONENTS genmsg rostest std_msgs)

if(CATKIN_ENABLE_TESTING)
  add_message_files(DIRECTORY msg
    FILES
    Arrays.msg
    ArrayVal.msg
    Embed.msg
    Floats.msg
    Simple.msg
    TVals.msg
    Val.msg
  )
  generate_messages(DEPENDENCIES std_msgs)
endif()

catkin_package()

if(CATKIN_ENABLE_TESTING)
  catkin_add_nosetests(test)
endif()

=== tools/rosbag_storage/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project(rosbag_storage)

if(NOT WIN32)
  set_directory_properties(PROPERTIES COMPILE_OPTIONS "-Wall;-Wextra")
endif()

find_package(console_bridge REQUIRED)
find_package(catkin REQUIRED COMPONENTS cpp_common roscpp_serialization roscpp_traits rostime roslz4)
find_package(Boost REQUIRED COMPONENTS date_time filesystem program_options regex)
find_package(BZip2 REQUIRED)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES rosbag_storage
  CATKIN_DEPENDS roslz4
  DEPENDS console_bridge Boost
)

# Support large bags (>2GB) on 32-bit systems
add_definitions(-D_FILE_OFFSET_BITS=64)

include_directories(include ${catkin_INCLUDE_DIRS} ${console_bridge_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS} ${BZIP2_INCLUDE_DIR})
add_definitions(${BZIP2_DEFINITIONS})

add_library(rosbag_storage
  src/bag.cpp
  src/bag_player.cpp
  src/buffer.cpp
  src/bz2_stream.cpp
  src/lz4_stream.cpp
  src/chunked_file.cpp
  src/message_instance.cpp
  src/query.cpp
  src/stream.cpp
  src/view.cpp
  src/uncompressed_stream.cpp
)

target_link_libraries(rosbag_storage ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${BZIP2_LIBRARIES} ${console_bridge_LIBRARIES})

install(TARGETS rosbag_storage
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/
  DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

=== tools/rosconsole/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(rosconsole)

if(NOT WIN32)
  set_directory_properties(PROPERTIES COMPILE_OPTIONS "-Wall;-Wextra")
endif()

find_package(catkin REQUIRED COMPONENTS cpp_common rostime rosunit)

find_package(Boost COMPONENTS regex system thread)

# select rosconsole backend
set(ROSCONSOLE_BACKEND "" CACHE STRING "Type of rosconsole backend, one of 'log4cxx', 'glog', 'print'")
set(rosconsole_backend_INCLUDE_DIRS)
set(rosconsole_backend_LIBRARIES)
if(ROSCONSOLE_BACKEND STREQUAL "" OR ROSCONSOLE_BACKEND STREQUAL "log4cxx")
  find_package(Log4cxx QUIET)
  if(NOT LOG4CXX_LIBRARIES)
    # backup plan, hope it is in the system path
    find_library(LOG4CXX_LIBRARIES log4cxx)
  endif()
  if(LOG4CXX_LIBRARIES)
    list(APPEND rosconsole_backend_INCLUDE_DIRS ${LOG4CXX_INCLUDE_DIRS})
    list(APPEND rosconsole_backend_LIBRARIES rosconsole_log4cxx rosconsole_backend_interface ${LOG4CXX_LIBRARIES})
    set(ROSCONSOLE_BACKEND "log4cxx")
  elseif(ROSCONSOLE_BACKEND STREQUAL "log4cxx")
    message(FATAL_ERROR "Couldn't find log4cxx library")
  endif()
endif()
if(ROSCONSOLE_BACKEND STREQUAL "" OR ROSCONSOLE_BACKEND STREQUAL "glog")
  find_package(PkgConfig)
  pkg_check_modules(GLOG QUIET libglog)
  if(GLOG_FOUND)
    list(APPEND rosconsole_backend_INCLUDE_DIRS ${GLOG_INCLUDE_DIRS})
    list(APPEND rosconsole_backend_LIBRARIES rosconsole_glog rosconsole_backend_interface ${GLOG_LIBRARIES})
    set(ROSCONSOLE_BACKEND "glog")
  elseif(ROSCONSOLE_BACKEND STREQUAL "glog")
    message(FATAL_ERROR "Couldn't find glog library")
  endif()
endif()
if(ROSCONSOLE_BACKEND STREQUAL "" OR ROSCONSOLE_BACKEND STREQUAL "print")
  list(APPEND rosconsole_backend_LIBRARIES rosconsole_print rosconsole_backend_interface)
  set(ROSCONSOLE_BACKEND "print")
endif()
message(STATUS "rosconsole backend: ${ROSCONSOLE_BACKEND}")

catkin_package(
  INCLUDE_DIRS include ${rosconsole_backend_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS}
  LIBRARIES rosconsole ${rosconsole_backend_LIBRARIES} ${Boost_LIBRARIES}
  CATKIN_DEPENDS cpp_common rostime
  CFG_EXTRAS rosconsole-extras.cmake
)

include(${CATKIN_DEVEL_PREFIX}/share/${PROJECT_NAME}/cmake/rosconsole-extras.cmake)

# See ticket: https://code.ros.org/trac/ros/ticket/3626
# On mac use g++-4.2
IF(${CMAKE_SYSTEM} MATCHES "Darwin-11.*")
  IF(EXISTS "/usr/bin/g++-4.2")
    set(CMAKE_CXX_COMPILER /usr/bin/g++-4.2)
  ELSE(EXISTS "/usr/bin/g++-4.2")
    # If there is no g++-4.2 use clang++
    set(CMAKE_CXX_COMPILER /usr/bin/clang++)
  ENDIF(EXISTS "/usr/bin/g++-4.2")
ENDIF(${CMAKE_SYSTEM} MATCHES "Darwin-11.*")

include_directories(include ${catkin_INCLUDE_DIRS} ${rosconsole_backend_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})

add_library(rosconsole_backend_interface src/rosconsole/rosconsole_backend.cpp)

add_library(rosconsole src/rosconsole/rosconsole.cpp)
target_link_libraries(rosconsole ${rosconsole_backend_LIBRARIES} ${catkin_LIBRARIES} ${Boost_LIBRARIES})

if(ROSCONSOLE_BACKEND STREQUAL "log4cxx")
  add_library(rosconsole_log4cxx src/rosconsole/impl/rosconsole_log4cxx.cpp)
  target_link_libraries(rosconsole_log4cxx rosconsole_backend_interface ${LOG4CXX_LIBRARIES} ${Boost_LIBRARIES})

  if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/speed_test.cpp")
    add_executable(rosconsole_speed_test test/speed_test.cpp)
    target_link_libraries(rosconsole_speed_test rosconsole ${rosconsole_backend_LIBRARIES} ${catkin_LIBRARIES} ${Boost_LIBRARIES})
  endif()
elseif(ROSCONSOLE_BACKEND STREQUAL "glog")
  add_library(rosconsole_glog src/rosconsole/impl/rosconsole_glog.cpp)
  target_link_libraries(rosconsole_glog rosconsole_backend_interface ${GLOG_LIBRARIES})
elseif(ROSCONSOLE_BACKEND STREQUAL "print")
  add_library(rosconsole_print src/rosconsole/impl/rosconsole_print.cpp)
  target_link_libraries(rosconsole_print rosconsole_backend_interface)
else()
  message(FATAL_ERROR "Unknown rosconsole backend '${ROSCONSOLE_BACKEND}'")
endif()

if(CMAKE_HOST_UNIX)
  catkin_add_env_hooks(10.rosconsole SHELLS sh DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/env-hooks)
else()
  catkin_add_env_hooks(10.rosconsole SHELLS bat DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/env-hooks)
endif()

install(TARGETS rosconsole rosconsole_${ROSCONSOLE_BACKEND} rosconsole_backend_interface
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})

install(FILES config/rosconsole.config
  DESTINATION ${CATKIN_GLOBAL_SHARE_DESTINATION}/ros/config)

install(DIRECTORY include/
  DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h")

if(CATKIN_ENABLE_TESTING)
  catkin_add_gtest(${PROJECT_NAME}-utest test/utest.cpp)
  if(TARGET ${PROJECT_NAME}-utest)
    target_link_libraries(${PROJECT_NAME}-utest ${PROJECT_NAME})
  endif()

  if(${CMAKE_SYSTEM_NAME} STREQUAL Linux)
    catkin_add_gtest(${PROJECT_NAME}-assertion_test test/assertion_test.cpp)
    if(TARGET ${PROJECT_NAME}-assertion_test)
      target_link_libraries(${PROJECT_NAME}-assertion_test ${PROJECT_NAME})
    endif()
  endif()

  catkin_add_gtest(${PROJECT_NAME}-thread_test test/thread_test.cpp)
  if(TARGET ${PROJECT_NAME}-thread_test)
    target_link_libraries(${PROJECT_NAME}-thread_test ${PROJECT_NAME})
  endif()
endif()

=== utilities/message_filters/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(message_filters)

if(NOT WIN32)
  set_directory_properties(PROPERTIES COMPILE_OPTIONS "-Wall;-Wextra")
endif()

find_package(catkin REQUIRED COMPONENTS roscpp xmlrpcpp rosconsole)
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES message_filters
  CATKIN_DEPENDS roscpp xmlrpcpp rosconsole
)
catkin_python_setup()

find_package(Boost REQUIRED COMPONENTS signals thread)

include_directories(include ${catkin_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})
link_directories(${catkin_LIBRARY_DIRS})

add_library(${PROJECT_NAME} src/connection.cpp)
target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES} ${Boost_LIBRARIES})

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h")

if(CATKIN_ENABLE_TESTING)
  # Ugly workaround for check_test_ran macro issue
  #add_subdirectory(test)
  find_package(catkin COMPONENTS rostest rosunit)

  include_directories(${GTEST_INCLUDE_DIRS})

  # ********** Tests **********
  catkin_add_gtest(${PROJECT_NAME}-msg_cache_unittest test/msg_cache_unittest.cpp)
  if(TARGET ${PROJECT_NAME}-msg_cache_unittest)
    target_link_libraries(${PROJECT_NAME}-msg_cache_unittest message_filters ${GTEST_LIBRARIES})
  endif()

  catkin_add_gtest(${PROJECT_NAME}-time_synchronizer_unittest test/time_synchronizer_unittest.cpp)
  if(TARGET ${PROJECT_NAME}-time_synchronizer_unittest)
    target_link_libraries(${PROJECT_NAME}-time_synchronizer_unittest message_filters ${GTEST_LIBRARIES})
  endif()

  catkin_add_gtest(${PROJECT_NAME}-test_synchronizer test/test_synchronizer.cpp)
  if(TARGET ${PROJECT_NAME}-test_synchronizer)
    target_link_libraries(${PROJECT_NAME}-test_synchronizer message_filters ${GTEST_LIBRARIES})
  endif()

  catkin_add_gtest(${PROJECT_NAME}-test_exact_time_policy test/test_exact_time_policy.cpp)
  if(TARGET ${PROJECT_NAME}-test_exact_time_policy)
    target_link_libraries(${PROJECT_NAME}-test_exact_time_policy message_filters ${GTEST_LIBRARIES})
  endif()

  catkin_add_gtest(${PROJECT_NAME}-test_approximate_time_policy test/test_approximate_time_policy.cpp)
  if(TARGET ${PROJECT_NAME}-test_approximate_time_policy)
    target_link_libraries(${PROJECT_NAME}-test_approximate_time_policy message_filters ${GTEST_LIBRARIES})
  endif()

  catkin_add_gtest(${PROJECT_NAME}-test_simple test/test_simple.cpp)
  if(TARGET ${PROJECT_NAME}-test_simple)
    target_link_libraries(${PROJECT_NAME}-test_simple message_filters ${GTEST_LIBRARIES})
  endif()

  catkin_add_gtest(${PROJECT_NAME}-test_chain test/test_chain.cpp)
  if(TARGET ${PROJECT_NAME}-test_chain)
    target_link_libraries(${PROJECT_NAME}-test_chain message_filters ${GTEST_LIBRARIES})
  endif()

  # Needs to be a rostest because it spins up a node, which blocks until it hears from the master (unfortunately)
  add_rostest_gtest(${PROJECT_NAME}-time_sequencer_unittest test/time_sequencer_unittest.xml test/time_sequencer_unittest.cpp)
  if(TARGET ${PROJECT_NAME}-time_sequencer_unittest)
    target_link_libraries(${PROJECT_NAME}-time_sequencer_unittest message_filters)
  endif()

  add_rostest_gtest(${PROJECT_NAME}-test_subscriber test/test_subscriber.xml test/test_subscriber.cpp)
  if(TARGET ${PROJECT_NAME}-test_subscriber)
    target_link_libraries(${PROJECT_NAME}-test_subscriber message_filters)
  endif()

  # Unit test of the approximate synchronizer
  catkin_add_nosetests(test/test_approxsync.py)
  catkin_add_nosetests(test/test_message_filters_cache.py)
endif()

=== utilities/xmlrpcpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(xmlrpcpp)

if(NOT WIN32)
  set_directory_properties(PROPERTIES COMPILE_OPTIONS "-Wall;-Wextra")
endif()

find_package(catkin REQUIRED COMPONENTS cpp_common)

# The CFG_EXTRAS is only for compatibility, to be removed in Lunar.
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES xmlrpcpp
  CATKIN_DEPENDS cpp_common
  CFG_EXTRAS xmlrpcpp-extras.cmake
)

include_directories(
  include
  libb64/include
  ${catkin_INCLUDE_DIRS}
)
link_directories(${catkin_LIBRARY_DIRS})

if(WIN32)
  add_definitions(-D_WINDOWS)
endif()

add_library(xmlrpcpp
  src/XmlRpcClient.cpp
  src/XmlRpcDispatch.cpp
  src/XmlRpcServer.cpp
  src/XmlRpcServerConnection.cpp
  src/XmlRpcServerMethod.cpp
  src/XmlRpcSocket.cpp
  src/XmlRpcSource.cpp
  src/XmlRpcUtil.cpp
  src/XmlRpcValue.cpp
  libb64/src/cdecode.c
  libb64/src/cencode.c
)

if(WIN32)
  target_link_libraries(xmlrpcpp ws2_32)
endif()

install(DIRECTORY include/${PROJECT_NAME}
  DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h")

install(TARGETS xmlrpcpp
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})

if (CATKIN_ENABLE_TESTING)
  add_subdirectory(test)
endif()

=== test/test_roscpp/test_serialization/CMakeLists.txt ===
if(NOT GTEST_FOUND)
  return()
endif()

catkin_add_gtest(${PROJECT_NAME}-serialization src/serialization.cpp)
if(TARGET ${PROJECT_NAME}-serialization)
  target_link_libraries(${PROJECT_NAME}-serialization ${catkin_LIBRARIES} ${GTEST_LIBRARIES})
  add_dependencies(${PROJECT_NAME}-serialization ${${PROJECT_NAME}_EXPORTED_TARGETS})
endif()

catkin_add_gtest(${PROJECT_NAME}-generated_messages src/generated_messages.cpp)
if(TARGET ${PROJECT_NAME}-generated_messages)
  target_link_libraries(${PROJECT_NAME}-generated_messages ${catkin_LIBRARIES} ${GTEST_LIBRARIES})
  add_dependencies(${PROJECT_NAME}-generated_messages ${${PROJECT_NAME}_EXPORTED_TARGETS})
endif()

add_executable(${PROJECT_NAME}-builtin_types EXCLUDE_FROM_ALL src/builtin_types.cpp)
add_dependencies(tests ${PROJECT_NAME}-builtin_types) 
target_link_libraries(${PROJECT_NAME}-builtin_types ${catkin_LIBRARIES} ${GTEST_LIBRARIES})
add_dependencies(${PROJECT_NAME}-builtin_types ${${PROJECT_NAME}_EXPORTED_TARGETS})
add_rostest(test/builtin_types.test)

add_executable(${PROJECT_NAME}-pre_deserialize EXCLUDE_FROM_ALL src/pre_deserialize.cpp)
add_dependencies(tests ${PROJECT_NAME}-pre_deserialize)
target_link_libraries(${PROJECT_NAME}-pre_deserialize ${catkin_LIBRARIES} ${GTEST_LIBRARIES})
add_dependencies(${PROJECT_NAME}-pre_deserialize ${${PROJECT_NAME}_EXPORTED_TARGETS})
add_rostest(test/pre_deserialize.test)

=== debian/changelog ===
ros-ros-comm (1.13.5+ds1-3) unstable; urgency=medium

  * Bugfix release while waiting for the version in NEW.
  * Add python-roslaunch to python-rostest (Closes: #894647)
  * Remove wrong ${misc:Depends}
  * Add missing dependencies
    (Closes: #896225, #896284, #896304, #896320, #896359, #896362, #896384)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 21 Apr 2018 09:14:16 +0200

ros-ros-comm (1.13.5+ds1-2) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * Update Vcs URLs to salsa.d.o

  [ Jose Luis Rivero ]
  * Added patch to solve problems with console-bridge 0.4 (Closes: #891517)

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 28 Feb 2018 20:23:08 +0100

ros-ros-comm (1.13.5+ds1-1) unstable; urgency=medium

  * New upstream version 1.13.5+ds1
  * Update copyright

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 10 Nov 2017 13:20:58 +0100

ros-ros-comm (1.13.3+ds1-1) unstable; urgency=medium

  * New upstream version 1.13.3+ds1
  * Remove patch, included upstream
  * update standards version

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 27 Oct 2017 15:30:36 +0200

ros-ros-comm (1.13.2+ds1-3) unstable; urgency=medium

  * Add patch for BSD (Closes: #876747)

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 29 Sep 2017 10:10:59 +0200

ros-ros-comm (1.13.2+ds1-2) unstable; urgency=medium

  * Include missing headers

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 24 Sep 2017 10:15:40 +0200

ros-ros-comm (1.13.2+ds1-1) unstable; urgency=medium

  * New upstream version 1.13.2+ds1
  * Update standards version (no changes needed)
  * Upload to unstable

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 23 Sep 2017 18:45:54 +0200

ros-ros-comm (1.13.1+ds1-1) experimental; urgency=medium

  * Add missing dependencies
  * add Multi-Arch according to hinter
  * Update watch file
  * Exclude files and repack orig
  * New upstream version 1.13.1+ds1
  * Rebase patches and bump rosbag and rosbag_storage soname
  * Remove xmlrpcpp hack
  * Update copyright
  * Update policy and debhelper versions
  * Update dependencies and multi-arch
  * Add patch for system libb64

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 15 Aug 2017 17:50:13 +0200

=== debian/control ===
Source: ros-ros-comm
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Moulard <thomas.moulard@gmail.com>,
           Jochen Sprickerhof <jspricke@debian.org>,
           Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 10), python, catkin, libroscpp-core-dev,
 python-rosunit, libconsole-bridge-dev, libboost-date-time-dev,
 libboost-filesystem-dev, libboost-program-options-dev, libboost-regex-dev,
 libboost-system-dev, libboost-thread-dev, libboost-signals-dev, liblz4-dev,
 ros-message-generation, libbz2-dev, libros-rosgraph-msgs-dev, libstd-msgs-dev,
 dh-python, python-dev, liblog4cxx-dev, libstd-srvs-dev, libboost-chrono-dev, libb64-dev
Standards-Version: 4.1.1
Vcs-Browser: https://salsa.debian.org/science-team/ros-ros-comm
Vcs-Git: https://salsa.debian.org/science-team/ros-ros-comm.git
Homepage: http://wiki.ros.org/ros_comm
X-Python-Version: >= 2.7


###########
# Clients #
###########

Package: libroscpp-dev
Section: libdevel
Architecture: any
Depends: libroscpp1d (= ${binary:Version}), ${misc:Depends}, python, libboost-signals-dev, libboost-filesystem-dev, libboost-system-dev, librosconsole-dev, libros-rosgraph-msgs-dev, libxmlrpcpp-dev, libroscpp-msgs-dev
Description: Robot OS development files for libroscpp
 This package is part of Robot OS (ROS). roscpp is a C++
 implementation of ROS. It provides a client library that enables C++
 programmers to quickly interface with ROS topics, services, and
 parameters.
 .
 roscpp is the most widely used ROS client library and is designed to be the
 high-performance library for ROS. ROS console output library.
 .
 This package contains the development files for the library.

Package: libroscpp1d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Robot OS client library
 This package is part of Robot OS (ROS). roscpp is a C++
 implementation of ROS. It provides a client library that enables C++
 programmers to quickly interface with ROS topics, services, and
 parameters.
 .
 roscpp is the most widely used ROS client library and is designed to be the
 high-performance library for ROS. ROS console output library.
 .
 This package contains the library.

Package: ros-roscpp-msgs
Section: devel
Architecture: all
Depends: ${misc:Depends}, ros-std-msgs
Description: Robot OS definitions of roscpp messages
 This package is part of Robot OS (ROS). roscpp is a C++ implementation of ROS.
 It provides a client library that enables C++ programmers to quickly interface
 with ROS topics, services, and
 parameters.
 .
 roscpp is the most widely used ROS client library and is designed to be the
 high-performance library for ROS. ROS console output library.
 .
 This package contains the message definitions.

Package: libroscpp-msgs-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Robot OS header for roscpp messages
 This package is part of Robot OS (ROS). roscpp is a C++ implementation of ROS.
 It provides a client library that enables C++ programmers to quickly interface
 with ROS topics, services, and
 parameters.
 .
 roscpp is the most widely used ROS client library and is designed to be the
 high-performance library for ROS. ROS console output library.
 .
 This package contains the generated C++ headers.

Package: python-roscpp-msgs
Section: python
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}
Description: Header for roscpp messages, Python
 This package is part of Robot OS (ROS). roscpp is a C++ implementation of ROS.
 It provides a client library that enables C++ programmers to quickly interface
 with ROS topics, services, and
 parameters. 
 .
 roscpp is the most widely used ROS client library and is designed to be the
 high-performance library for ROS. ROS console output library.
 .
 This package contains the generated Python package.

Package: cl-roscpp-msgs
Section: lisp
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Header for roscpp messages, LISP
 This package is part of Robot OS (ROS). roscpp is a C++
 implementation of ROS. It provides a client library that enables C++
 programmers to quickly interface with ROS topics, services, and
 parameters.
 .
 roscpp is the most widely used ROS client library and is designed to be the
 high-performance library for ROS. ROS console output library.
 .
 This package contains the generated LISP library.

Package: python-rospy
Section: python
Architecture: all
Multi-Arch: allowed
Depends: ${python:Depends}, ${misc:Depends}, python-std-msgs, python-rosgraph, python-roscpp-msgs, python-rosgraph-msgs, python-yaml, python-roslib
Description: Python client library for Robot OS
 This package is part of Robot OS (ROS). The rospy client API enables
 Python programmers to quickly interface with ROS topics, services,
 and parameters. The design of rospy favors implementation speed
 (i.e. developer time) over runtime performance so that algorithms can
 be quickly prototyped and tested within ROS. It is also ideal for
 non-critical-path code, such as configuration and initialization
 code. Many of the ROS tools are written in rospy to take advantage of
 the type introspection capabilities.
 .
 Many of the ROS tools, such as rostopic and rosservice, are built on
 top of rospy.


#########
# Tools #
#########

Package: librosbag-dev
Section: libdevel
Architecture: any
Depends: librosbag3d (= ${binary:Version}), ${misc:Depends}, librosbag-storage-dev, librosconsole-dev, libroscpp-dev, libtopic-tools-dev, libxmlrpcpp-dev
Description: Tools for recording from and playing back to Robot OS topics
 This package is part of Robot OS (ROS). It is the development files
 for the rosbag library, which provides APIs for reading/writing bags
 (ROS message stores) in C++ and Python.
 
Package: librosbag3d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Library for recording from and playing back to Robot OS topics
 This package is part of Robot OS (ROS). It is the rosbag library,
 which provides APIs for reading/writing bags (ROS message stores) in
 C++ and Python. It is intended to be high performance and avoids
 deserialization and reserialization of the messages.
 .
 The related rosbag package provides a command-line tool for working
 with bags.

Package: python-rosbag
Section: python
Architecture: any
Multi-Arch: allowed
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}, python-roslib, python-rospy, python-roslz4
Description: Python tools for recording from and playing back to Robot OS topics
 This package is part of Robot OS (ROS). It provides a command-line
 tool for working with bags (ROS messages stores). The corresponding
 librosbag package provides corresponding C++ and Python APIs.

Package: librosbag-storage-dev
Section: libdevel
Architecture: any
Depends: librosbag-storage2d (= ${binary:Version}), ${misc:Depends}, libconsole-bridge-dev, libboost-date-time-dev, libboost-filesystem-dev, libboost-program-options-dev, libboost-regex-dev, libroslz4-dev, libbz2-dev
Description: Development files for librosbag_storage
 This package is part of Robot OS (ROS). It is a set of tools for
 recording from and playing back ROS messages without relying on the
 ROS client library.
 .
 This package contains the development files for the library.

Package: librosbag-storage2d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Robot OS library for rosbag_storage
 This package is part of Robot OS (ROS). It is a set of tools for
 recording from and playing back ROS messages without relying on the
 ROS client library. 
 .
 This package contains the library.

Package: librosconsole-dev
Section: libdevel
Architecture: any
Depends: librosconsole2d (= ${binary:Version}), libboost-regex-dev, libboost-system-dev, libboost-thread-dev, libroscpp-core-dev, liblog4cxx-dev, ${misc:Depends}
Description: Development files for librosconsole
 This package is part of Robot OS (ROS). It is the ROS console output
 library, a C++ package that supports console output and logging in
 roscpp. It provides a macro-based interface which allows both printf-
 and stream-style output. It also wraps log4cxx, which supports
 hierarchical loggers, verbosity levels and configuration-files.
 .
 This package contains the development files for the library.

Package: librosconsole2d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: library for librosconsole
 This package is part of Robot OS (ROS). It is the ROS console output
 library, a C++ package that supports console output and logging in
 roscpp. It provides a macro-based interface which allows both printf-
 and stream-style output. It also wraps log4cxx, which supports
 hierarchical loggers, verbosity levels and configuration-files.
 .
 This package contains the library.

Package: python-rosgraph
Section: python
Architecture: all
Multi-Arch: allowed
Depends: ${python:Depends}, ${misc:Depends}, python-yaml
Description: Command-line tool to print information about the Robot OS computation graph
 This package is part of Robot OS (ROS). rosgraph contains the
 rosgraph command-line tool, which prints information about the ROS
 computation graph. It also provides an internal library that can be
 used by graphical tools.

Package: python-roslaunch
Section: python
Architecture: all
Multi-Arch: allowed
Depends: ${python:Depends}, ${misc:Depends}, python-rosclean,
 rosout, python-rospkg, python-rosgraph, python-roslib, python-rosmaster,
 python-rosgraph-msgs, python-netifaces, python-rosparam, python-yaml
Description: roslaunch tool for Robot OS
 This package is part of Robot OS (ROS). roslaunch is a tool for
 easily launching multiple ROS nodes locally and remotely via SSH, as
 well as setting parameters on the Parameter Server. It includes
 options to automatically respawn processes that have already died.
 roslaunch takes in one or more XML configuration files (with the
 launch extension) that specify the parameters to set and nodes to
 launch, as well as the machines that they should be run on.
 .
 This package contains the roscore program.

Package: python-rosmaster
Section: python
Architecture: all
Multi-Arch: allowed
Depends: ${python:Depends}, ${misc:Depends}, python-rosgraph, python-rospkg, python-defusedxml
Description: Robot OS Master implementation
 This package is part of Robot OS (ROS). The rosmaster package
 implements the ROS Master. Most programs will not need to interact
 with this package directly. The rosmaster is run automatically
 whenever roscore is run and all communication with the Master happens
 over XMLRPC APIs.


Package: python-rosmsg
Section: python
Architecture: all
Multi-Arch: allowed
Depends: ${python:Depends}, ${misc:Depends}, python-rosgraph, python-rospkg, python-roslib, python-rosbag, python-genpy
Description: Command-line tools for displaying information about Robot OS
 This package is part of Robot OS (ROS). rosmsg is a command-line tool
 for displaying information about ROS Message types. rossrv is a
 command-line tool for displaying information about ROS Service types.

Package: python-rosnode
Section: python
Architecture: all
Multi-Arch: allowed
Depends: ${python:Depends}, ${misc:Depends}, python-rosgraph, python-rostopic
Description: Command-line tool for displaying debug information about Robot OS
 This package is part of Robot OS (ROS). rosnode is a command-line
 tool for displaying debug information about ROS Nodes, including
 publications, subscriptions and connections. It also contains an
 experimental library for retrieving node information. This library is
 intended for internal use only.

Package: rosout
Section: misc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Description: Robot OS system-wide logging mechanism

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh  $@ --with=python2 --buildsystem=cmake

get-orig-source:
	uscan --verbose --force-download --repack --compress xz

=== debian/watch ===
version=4
opts="dversionmangle=s/\+ds\d*$//,repacksuffix=+ds1,\
    filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ros-ros-comm-$1.tar.gz%" \
    https://github.com/ros/ros_comm/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
